/**
 * PHPDevShell is a RAD Framework aimed at developing any web based application/website.
 *
 * @package PHPDevShell
 * @link http://www.phpdevshell.org
 * @copyright Copyright (C) 2012 Jason Schoeman, All rights reserved.
 * @license GNU/LGPL, see readme/licensed_under_lgpl or http://www.gnu.org/licenses/old-licenses/lgpl-2.1.html
 * @author Jason Schoeman, Contact: titan [at] phpdevshell [dot] org.
 *
 * Copyright notice: See readme/notice
 * By using PHPDevShell you agree to notice and license, if you dont agree to this notice/license you are not allowed to use PHPDevShell.
 */

* To view detailed changes use a bazaar client and download log from
* https://code.launchpad.net/phpdevshell
* Note that that the db version and code version does not mean it will always be the same with each release.
* V1.0.5-Stable-DB-1003 means the code version is released at 1.0.5 and the db version at 1003

PHPDevShell V 3.2.0-Stable-DB-3140 (Revision-bzr 898)
-----------------------------------------------------
Information:
Major release focuses on Ajax capabilities and general structure enhancements. It also ensures better maintainability of views.

IMPORTANT:
There are a few small changes that might remove styling from your controllers if you use the default theme, please check the website to identify these changes.
The reason for this is the fact that instead of calling the whole jquery-ui js code base, we only call the core and plugins needs to be called explicitly, this speeds up things allot.

Detail on reports can viewed at https://bugs.launchpad.net/phpdevshell/

[Improved] Several UI improvements made.
[Improved] Performance (Yes PHPDevShell is even lighter).
[Improved] Enhanced ajax possibilities.
[Improved] W3C validation of forms.
[NEw] New notification and notice system.
[Improved] Added fieldset and legend to forms for better css control of default ui.
[New] New grid system (based on grid 1140) allowing better compatibility with mobile devices (compatible with old code).
[Improved] Multi-select and select fields.
[New] New /other/sync.sh to update third party projects with latest version of PHPDevShell.
[Improved] Exception reports was greatly improved allowing logging of full exceptions.
[Improved] Menus now allows a custom menu id, it also does not create duplicated menus anymore when id changes.
[Improved] Theme styling and modification is now easier.
[Improved] Mods system and new mods to override.
[Improved] Example plugin.
[Bug] #928149 Creating different plugins pointing to same named file, overrides original.
[Bug] #934297 Ajax and JSON request problems.
[Bug] #942452 Default included cronjobs gives error dude to $keyField using old __auto__.
[Bug] #943806 Mysql Connector to PDO Connector Conversion.
[Bug] #997580 Silent exception reporting, reporting nothing that can help find the bug.
[Bug] #1005822 login.php blank bug.
[Bug] #1006308 On a session timeout, the login theme is displayed using default theme instead of selected theme.
[Bug] #1007191 can't choose several roles for a menu access.
[Bug] #929395 <span> end tag missing in themes.
[Bug] #929992 Complex symlink to parent menu configuration bug.
[Bug] #942449 Cronjob executer should be themeless.
[Bug] #949314 ReadBean ORM plugin does not take into account the database server.
[Bug] #949381 legacyConnecter::free() not returning with result.
[Bug] #968152 iana additional functionality needed.
[Bug] #977958 Option to dictate menu id.
[Bug] #985480 Control Panel menu's in rare conditions rendered more than once.
[Bug] #986123 JQuery Multiselect widget clicking not working that great.
[Bug] #997547 Duplicating menus when changing menu id or path.
[Bug] #921467 Edit a cronjob in the cronjob manager.
[Bug] #932167 Confusing details about caching in PHPDS-defaults.config.php.
[Bug] #932577 getSettings should not return undefined settings, it should set it to NULL.
[Bug] #997119 Removed notif, broken html in tooltip.
[Bug] #949110 Support for multiple database configurations as well as PDO (Core only supports MySQL still).

PHPDevShell V 3.1.3-Stable-DB-3130 (Revision-bzr 817)
-----------------------------------------------------
Information:
Minor maintenance release focusing on stability.

Detail on reports can viewed at https://bugs.launchpad.net/phpdevshell/

[New] Added a log file viewer UI screen to view logs written in files.
[Improved] #924728 Changed the default behaviour of how arrays are created, by default the array key will now auto increment instead of using primary database key.
[Improved] #924683 Removed the id columns for groups and roles as the two remaining columns creates a unique key together when both serves as primary keys.
[Improved] #924430 Added column index for database column structure which in turn improves performance.

PHPDevShell V 3.1.2-Stable-DB-3120 (Revision-bzr 813)
-----------------------------------------------------
Information:
Minor maintenance release focusing on stability.

Detail on reports can viewed at https://bugs.launchpad.net/phpdevshell/

* [Bug] #863646 When using the +New button on groups, roles, users and menus sometimes linked tags gets deleted.
* [Improved] #915873 When a template file cant be found, default cloud should be used.
* [Improved] #915878 Autoloader should dig deeper to find unregistered plugin class.
* [Improved] Error reporting on missing module methods.
* [New] #915881 Unobtrusive way to catch spam from submitting forms.
* [New] #915882 Class handler moved to own file.
* [New] Added property to instantly change controller theme.
* [Other] Other minor fixes and updates.

PHPDevShell V 3.1.1-Stable-DB-3110 (Revision-bzr 804)
-----------------------------------------------------
Information:
Major maintenance release with added functionality, performance increases and new CRUD and ORM system.
Upgrading is highly recommended.

Detail on reports can viewed at https://bugs.launchpad.net/phpdevshell/

* [New] Complete CRUD system.
* [New] Complete ORM system powered by RedBeanPHP.
* [New] Ability to call factory class like singleton for sharing an instance.
* [Improved] #692558 Improved theme.js handling with the ability to re-apply JS to script ran after initial render.
* [Improved] Some core improvements was made.
* [Improved] 90% of forms was moved to PHPDevShell CRUD system.
* [Improved] General UI forms now does better validation.
* [Bug] #902123 Various registration bugs.
* [Improved] #894291 Improvement to menu href link generation logic.
* [Improved] #906355 Option was added to stick to root menu line of menus.
* [Bug] #902126 Enterering deeper into dashboard tree shows no breadcrumbs.
* [Improved] Control panel was rewritten to be more consistent and folder like in behaviour.
* [New] Added new UI class registry manager.
* [Improved] Performance by dropping old legacy classes.
* [Improved] General theme improvements.
* [Improved] #894315 Menus can now contain advanced parameter data.
* [Bug] #902124 Not using sef produces no page errors.
* [Bug] #906556 Class alias declaration fails on rank="first".
* [Improved] Rewrote mods theme system again by converting it into a class system.
* [Improved] Better contact admin page with the option to add different emails for different contact categories.
* [Improved] Translation systems default text.


PHPDevShell V 3.0.5-Stable-DB-3004 (Revision-bzr 764)
-----------------------------------------------------
Information:
Major maintenance release focused on features, security, performance and stability.
Upgrading is highly recommended.
No database changes.

-----------------------------------------------------------------------------------------------------------
* PS: Please make sure you are using latest .htaccess file else you might see a blank page after upgrading.
-----------------------------------------------------------------------------------------------------------

Detail on reports can viewed at https://bugs.launchpad.net/phpdevshell/

* [Security] Fixed Flaw 887044 (gzip).
* [Bug] #882589 Information text on some UI screens was not informative.
* [New] #885201 Include support for alias groups to allow specific action permission within a page if ($user->groupCan('edit'))...
* [New] #757594 Changing menu path now allows to delete old menu as ID will change.
* [Bug] #839592 When setting the login redirect in General Settings UI, to something other then Login-Logout, when incorrect user/password is used it just posts to the newly selected redirect login page without displaying incorrect login details.
* [New] #804365 When editing a menu item which is a link to another item, it would be nice to have a direct link to go editing the target menu item.
* [Bug] #808784 Fixed error when editing a menu with a ' (single quote).
* [Bug] #856746 Fixed PHP_VERSION check bug in class.phpmailer.php
* [Bug] #869128 Fixed output buffering issue when error occurs during Plugin Upgrade.
* [Bug] #854559 Fixed pending users wont always clear when approving them.
* [Bug] #664927 Fixed cannot hide Log In | Out button from logged in users.
* [Bug]	#716823 Fixed problem with absolute session directory.
* [Bug] #719390	User extra groups/roles are not unique.
* [New] #721090 Move the password pref to a separate page.
* [Improved] #737356 Optimize menu database query.
* [Bug] #783909 Fixed redirect Login setting not working.
* [Bug] #767248 Fixed function tagList($name, $object, $target = null) broken.
* [Bug] #778150 Fixed Exception when removing a plugin without any menu's.
* [Bug] #863646 Fixed editing a menu wipes out all its tags.
* [Bug] #881397 Fixed menus access error reporting broken.
* [Improved] #881418 Ending "l" at end of menus ugly.
* [Bug] #881438 Fixed editing menu reports warning falsely.
* [Bug] #882587 Fixed cronjob should log as done earlier.
* [Improved] #884664 Better Firephp header send check.
* [Bug] #884665 Fixed uninstall does not execute uninstall queries.
* [Improved] #884714 Plugin manager.
* [New] #884720 Fast search filter for none paginated screens.
* [Improved] #884726 Improve theme ui understanding and icons.
* [New] #887470 Add widget, lightbox and ajax node types with easy call.
* [Bug] #887473 Fixed 404 and 403 errors not returning correct codes.
* [Bug] #887477 Reinstalling menu's looses all previous menu edits.
* [Improved] #887902 Rewrite modules system making it lighter, more powerful and easier to use.
* [Improved] #887903 Logged in page shows too much info.
* [Improved] General performance.
* [Updated] TinyMCE, PHPMailer, JQuery + UI, Smarty
* [Improved] Login mechanism and modularity.

PHPDevShell V 3.0.4-Stable-DB-3004 (Revision-bzr 692)
-----------------------------------------------------
Information:
Maintenance release focused mostly on performance and stability.

* [Improved] Loading time appearance of heavy jquery pages like tabs. It now all shows up at once.
* [New] Added small PHP memory usage with query usage.
* [Updated] To latest JQuery, TinyMCE, FirePHP and Smarty.
* [New] CDN where you now have the ability to show images and other static scripts from a light CDN server improving performance.
* [Bug] Fixed menus showing incorrectly on darker themes. Top and bottom of dropdown only is now rounded.
* [Improved] General loading times of pages.
* [Improved] Caching mechanism was rewritten to allow support for other cache engines with performance improvements.
* [New] Added notes column to add notes with settings, can also pass notes from plugin configuration xml.
* [New] Added description for file uploads.
* [Bug] Fixed FirePHP not passing values to browser.
* [Bug] Fixed sessions not expiring.
* [Improved] Rewrote login mechanism as plugin.
* [New] Immediate login capabilities without redirect.
* [Improved] PHPDevShell default memory usage lowered by average 30%
* [Improved] PHPDevShell default page loading times improved by average 15%
* [New] 404 page, 403 page, Permission Error page and Guest Permission pages.
* [Bug] Authentication Required now detects login required correctly.
* [Improvement] Slow loading pages where jquery is loaded like with tabs now display once everything is loaded instead of half loaded CSS in between.
* [Bug] Fixed code that caused Declaration of childClass::customMethod() should be compatible with that of parentClass::customMethod() notifications.
* [New] userActions added to extend functionality on usersImportAction, pendingUserMassAction, pendingUserDeleted, pendingUserBanned, pendingUserApproved, userMultipleUpdate, userChangedPassword, userRegisterVerified, userRegister, userEditPreferences, userUpdate, userAdd, userDelete

PHPDevShell V 3.0.3-Stable-DB-3002 (Revision-bzr 685)
-----------------------------------------------------
Information:
Maintenance release focusing on stability.

* [New] Tagger UI with tagging option in UI for Users, Groups, Roles and Menus.
* [Bug] Fixed user import bug where imported file could not be found (Jozefus).
* [Bug] Fixed and improved query for getGroups to include child groups for a user who belongs to parent.
* [Improved] Improved query for getRoles.
* [Bug] Assigning correct permission on fresh install.
* [Bug] Fixed Ajax not working correctly on menu ui.
* [Bug] Fixed phantom menu that will display ul tags when permission for children was not set.
* [Bug] Fixed serious issue with smarty sections not displaying results correctly and dropping rows.
* [Bug] Fixed bug where plugin without menus cant be uninstalled.
* [New] Added native methods newQuery and sqlQuery to do direct sql queries without the need for models.
* [Bug] Other minor bugs fixed...

PHPDevShell V 3.0.2-Stable-DB-3001 (Revision-bzr 678)
-----------------------------------------------------
Information:
Maintenance release focusing on stability.

* [Bug] Fixed multiple platform installation issues especially WAMP.
* [Update] JQuery to 1.5.2.
* [Bug] Fixed password recovery bug.
* [Bug] Multiple unreported smaller bugs fixed.
* [Bug] Fixed password change page.

PHPDevShell V 3.0.1-Stable-DB-3001 (Revision-bzr 664)
-----------------------------------------------------
Information:
First maintenance release for the 3.x.x branch. This branch mainly focuses on stability.

* [Bug] Fixed and Improved get Roles and get Groups methods.
* [Update] JQuery and other javascript classes.
* [Update] Updated TinyMCE to latest version.
* [Bug] Multiple unreported smaller bugs fixed.
* [Improved] Minor UI tweaks and improvements.

PHPDevShell V 3.0.0-Stable-DB-3001 (Revision-bzr 657)
-----------------------------------------------------
Information:
After many many months, PHPDevShell V3.0.0 is finally ready. This update brings the last found bugs as reported.

* [Bug] Added missing token icon.
* [Bug] Fixed undefined variable error in search filter.
* [Improved] General code optimization.
* [Bug] Fixed incorrecting naming of jquery files in themes.


PHPDevShell V 3.0.0-RC-1-DB-3001 (Revision-bzr 647)
-----------------------------------------------------
Information:
Mostly bug fixes and further stability improvements.

* [Update] JQuery and UI with components updated to latest versions.
* [Update] Updated TinyMCE to latest version.
* [Bug] Fixed config manager where changed values wont save.
* [New] Added fancybox to the list of ui tools available.
* [New] Added timepicker when a timepicker is needed with jquery date select.
* [Bug] #704119 Changing template gives Undefined index: new_window_array
* [Improved] Added pagination example to example plugin.
* [Improved] Extended example plugin to include helper class.
* [Bug] Fixed core to load models for helper classes.
* [Update] Smarty updated to latest version.
* [Bug] Fixed two notices ($time and $packages) in install.php
* [Bug] Fixed config loading order.
* [Improved] FOUC (Flash of Unstyled Content) before tabs are initialized, not 100% but better looking.
* [Bug] Fixed a bug where readme url alias clashes with readme folder. read-me alias is now installed by default.
* [New] Added emptyCloud based on cloud for pure view.
* [Bug] #692707 Using empty template causes error.
* [Bug] #691397 Jquery show/hide icon gets out of sync.
* [Bug] Fixed a few undefined variables.
* [Bug] Fixed a display but in PHPDS_errorHandler where "php" appear on each line of the code fragments.
* [New] Added reporting on notices.
* [Improved] Added checks when upgrading tables.

PHPDevShell V 3.0.0-Beta-4-DB-3001 (Revision-bzr 622)
-----------------------------------------------------
Information:
Bugfixes and optimizations. This is the last beta of the 3.0.0 branch. RC-1 will follow next.

* [New] Added option to enable caching for views.
* [Bug] #687603 Force compile while in development.
* [Bug] #664913 System admin tabs don't work.
* [Bug] Fixed search field disapearing when no values are found.
* [Bug] Fixed bug that prevents access after install due to cookie.
* [Bug] #687580 Uninstall settings in plungin.config not working.
* [New] Ability to have easy views.
* [Improved] Updated documentation with new pages.
* [New] Improved API documentation system.
* [Improved] Installation is now easier with less confusing configuration files.
* [Bug] #684699 Auto upgrader for plugins working again.
* [Update] JQuery and UI updated to latest versions.
* [New] #656920 Add 404 - not found page.
* [Bug] #663125 Mail and accentuated chars.
* [Bug] #673640 Error when going up one Menu item to placeholder only.
* [Bug] #680490 $this->navigation->menuFile() does not return full path to file.
* [Bug] #673618 Malformed email error.
* [Bug] #664401 All items can now be saved by clicking on new, while it will base the next entry on the core settings of previous entry.
* [Bug] #677910 Undefined variable extend_to when installing new plugin.
* [Bug] #673607 Plugin dependency is now according to class names provided. The same plugin can provide multiple dependencies. Dependencies can also be override.

PHPDevShell V 3.0.0-Beta-3-DB-3001 (Revision-bzr 594)
-----------------------------------------------------
Information:
Major cleanup.

* [New] ExamplePlugin added.
* [Update] Smarty core is now stable at V 3.0.4
* [Bug] Fixed serious views bug.
* [Security] Fixed serious incorrect default permissions settings.
* [Bug] Fixed faulty installer and upgrader.
* [New] Added custom 404 page.
* [New] Added to the big 5 we now have a $this->user class.
* [Bug] Fixed various Plugins bugs.
* [Update] Converted all plugins according to coding practices.
* [Update] Striped all queries out to correct models.
* [Update] Complete core conversion to latest coding practices.
* [Improved] Various undocumented bugs fixed.

PHPDevShell V 3.0.0-Beta-2-DB-3000 (Revision-bzr 566)
-----------------------------------------------------
Information:
General beta maintenance and bug fix release.

* [Improved] Installer and upgrader.
* [Bug] Database charset with option to set it at runtime.
* [Update] JQuery from 1.4.2 to 1.4.3.
* [Bug] #658763 Cannot change assigned User Roles under Edit Menu Item.
* [Bug] #659198 Serious bug under windows where system wont install or run (Can't find any 'template' because dependancy is wrong).
* [Bug] #660958 Default install values not loaded in Windows.
* [Bug] #659198 Improved error handler.
* [Bug] #658571 Forgets what tab it was on when saving a System Setting.
* [Bug] #655634 Double/empty field with floating headers.
* [Bug] #658699 Super admin cannot Edit a Group from Manage Groups.
* [Bug] #658465 Bazaar cannot do checkout of beta 1 on windows due to symlinks
* [Bug] #636111 Cannot use https.
* [Improved] Remember me function.
* [Bug] #658544 Link from install to main index.php


PHPDevShell V 3.0.0-Beta-1-DB-3000 (Revision-bzr 547)
-----------------------------------------------------
Information:
PHPDevShell V 3.0.0 is almost a full rewrite.

* [New] Query class to separate "model" from "logic" (MVC paradigm).
* [New] Scripts can be of class "controller" (MVC paradigm).
* [Improvement] Class autoloader deals with ".local" files and models files.
* [New] Unit testing to help prevent regressions.
* [Improvement] Advanced handling of errors and exception.
* [Improvement] Conduits for error/debug logs (firephp, files, mail...).
* [Improvement] Better consistency of code structure and naming.
* [New] Tagging system (UI not completed).
* [New] Advanced OOP structure, including dependency injection, pseudo multiple inheritance, factory...
* [Update] New installer and upgrade.
* [New] Powerful plugin manager to have both type classes and resource sharing.
* [Improvement] Language translation system.
* [New] Plugin TinyMCE V3.3.8
* [New] Plugin Smarty V3.0.0 RC-4
* [Improved] Completely redesigned HTML 5 theme.
* [New] Theme engine.
* [New] JQuery Skins with JQuery UI 1.8.5 and JQuery 1.4.2
* [Improved] Full MVC conversion of PHPDevShell plugin.
* [Improved] PHPDevShell plugin tranformed to HTML5.
* [New] Plugin PHPMailer V5.1
* [New] Pagination and Search Plugin.
* [New] FileMan Plugin.
* [New] ControlPanel Plugin.
* [New] Plugin PHPThumbs V3.0.66.
* [Improved] Administration screens.
* [New] Icon system.
* [New] Ajax system.
* [Improved] Database system.
* [Improved] Security system.
* [Improved] Navigation system.
* [Improved] Configuration system.
* [Removed] Hooks, will soon be replaced by more advanced widget system.

Note, we tried to make old plugins still work on PHPDevShell V3.0.0 however, you will have to switch your theme to oldlegacy2 for your custom administration menus. Backwards compatibility
will improve throughout the betas.

PHPDevShell V 2.8.1-Stable-DB-2800 (Revision-bzr 262)
-----------------------------------------------------
Information:
PHPDevShell V 2.8.1 is a minor release, mainly adding the new "Auto Upgrade" functionality.
The "Auto Upgrade" system allows you to upgrade both plugins and core automatically in just 2 clicks.

* [New] Automatic plugin and core upgrade feature.
* [Improvement] Minor cloud theme improvements for cleaner looks.
* [Update] PHP Thumbnailer V 3.0.0 upgraded.
* [New] New local FTP server for local file writing.

PHPDevShell V 2.8.0-Stable-DB-2800 (Revision-bzr 243)
-----------------------------------------------------
Information:
PHPDevShell V 2.8.0 is a massive release, adding both to features and flexibility. This releases pushes PHPDevShell to a enterprise ready platform.

* [New] Installation process and database install script gui.
* [Bug] Small plugin activation bug when folder empty.
* [Improved] Email validation.
* [Improved] General settings is now neatly tabbed.
* [Improved] JQuery UI theme improved to better sync with templates.
* [Bug] #400694 Warning when adding a new hook.
* [Bug] #401964 Use of local language when adding menu.
* [New] Complete FirePHP/FireBug support added.
* [Improved] Readme to include left out open-source projects in thanks.
* [Improved] Performance by removing constant assignment.
* [Improved] Performance by improving menu name indexing.
* [New] Smarty template engine support added with PHPDevShell templates split.
* [New] Ability to have multiple template layouts per script.
* [Update] TinyMCE 3.2.5
* [Clean-up] Folder names and file names.
* [Improved] User groups and User roles delete icon in Group and Role management.
* [New] Master ErrorHandler class with error handling capabilities.
* [Improved] Refactored writable directories.
* [Bug] #393741 Ability to filter by group/role name in user list.
* [Bug] #383426 When editing a menu with an error, user role doesn't stick.
* [Bug] #385491 Dynamic prefix in plugin install.
* [Bug] #393344 Gettext error in Windows.
* [Improved] Header handling.
* [Update] JQuery UI to V 1.7.2
* [New] Debug information.
* [Improved] Core engine.
* [Other] Multiple minor bugs, improvements...

PHPDevShell V 2.7.0-Stable-DB-2701 (Revision-bzr 85)
----------------------------------------------------
Information:
PHPDevShell V 2.7.0-Stable is a major release while introducing the new OOP engine.
The project tracking and management us now done on https://launchpad.net/phpdevshell

Most significant changes:

* [Improved] Registration system improvements.
* [Improved] Major OOP engine improvements.
* [Improved] Major language system improvements.
* [Improved] Configuration engine.
* [New] Mass mailer frontend on the PHPMailer V 5.0.2 backend, plugin called HerculesPostman.
* [New] Advanced file upload management with image manipulation running thumbnail class V 2.0 from ian@gen-x-design.com
* [Update] Updated tinymce to V3.2.3.1 with various config improvements.
* [Update] Various default template visual enhancements.
* [New] Printable template version producing a fast mode too.
* [New] Integration of jquery and jquery gui framework.
* [New] User import functionality.
* [New] Ability to delete users per group.
* [New] 376341 Show search filter is engaged.
* [Bug] 374895 Inconsistant behaviour in Login screen.
* [Bug] 374898 Plugin GUI wrong menu language file check.
* [Bug] 374904 Future and past $core->user_server_tz_diff dst failure.
* [Bug] 375138 Imported field not unquoted.
* [Bug] 375288 PHP DateTime bug may cause problems within PHPDevShell.
* [Bug] 375294 Multiple coding typographical errors.
* [Improved] 376480 Less conspicuous Immediate Halt message.
* [Bug] 375290 Edit menus does not show on some items.
* [Bug] 375292 Mandatory fields unclear.
* [Bug] 375298 Warnings.
* [Bug] 376458 New menu mandatory fields problem .
* [Bug] Incorrect plugin path info with double // slashes.
* [Bug] Undefined variable assigned.
* Various other improvements and fixes done.


Please submit bugs at https://bugs.launchpad.net/phpdevshell
If you dont submit the bugs we dont know about them!

PHPDevShell V 2.6.2-Stable-DB-2620 (Revision 838)
-------------------------------------------------
Information:
PHPDevShell V 2.6.2-Stable is a major maintenance release fixing and improving the i18n language system.

Most significant changes:

* [New] Users can now manage their locale format according to their server.
* [New] System info now also shows global available user and configuration data.
* [New] All language PO templates created and included in distribution package.
* [Bug] Broken language (i18n) system was fixed and simplified.
* [New] New function to calculate time difference between user and server.
* [Bug] Minor bug fixes.

Please submit bugs at https://bugs.launchpad.net/phpdevshell
If you dont submit the bugs we dont know about them!

PHPDevShell V 2.6.0-Stable-DB-2600 (Revision 785)
-------------------------------------------------
Information:
PHPDevShell V 2.6.0-Stable is a major maintenance release for increased stability and bug fixes, with support
for memcache added and new improved time system.

Most significant changes:

* [Improved] Fixed plugin manager where settings write needed to be first for it to work.
* [Improved] Mouse clicking problem where users found it difficult to navigate.
* [Improved] Improved how hooks cache are handled with slightly lighter method calling relative hooks.
* [New] Full memcache support was added as a caching system.
* [New] Extra gui setting to choose the login and logout screen if user has custom screen.
* [Bug] Fixed login and logout shortcut to enable seo.
* [Bug] Fixed long name menus wrapping.
* [Improved] Menu navigation easier.
* [Improved] Improved Google Chrome browser compatibility.
* [Bug] Fixed broken pagination navigation when seo is enabled.
* [Bug] Fixed breadcrumb seo navigation menus.
* [Improved] Dramatically improved timezone system with included DST calculations.
* [New] Added short date format in gui settings.
* [Bug] Fixed broken logout button in logout/in script.
* [Update] Install and upgrade information updated.

Roadmap: We will be spending some time improving the documentation on the language system to explain it in simpler terms.

Please submit bugs at https://bugs.launchpad.net/phpdevshell
If you dont submit the bugs we dont know about them!

PHPDevShell V 2.5.0-Stable-DB-2500 (Revision 771)
-------------------------------------------------
Information:
PHPDevShell V 2.5.0-Stable is a major maintenance release bringing more stability and added features to the table.

Most significant changes:

* [Improved] Improvement to core function format_time_date
* [Improved] Major improvements was made on how the system handles groups and roles.
* [Bug] When a branch admin wanted to approve a pending queue registration he/she must belong to the pending status group instead of the result group after approved.
* [Bug] The login gui randomly said the script was not validating.
* [Improved] An improved tooltip system was introduced bring better browser compatibility.
* [New] The possibility to create a menu alias and have it as a search friendly menu item.
* [Bug] Classes did not autoload in menu type cronjobs on auto execution from system.
* [Bug] When a template was removed, it still shows in the dropdown when assigning templates in template listing.
* [Bug] Special characters like the pound sign returns scramble if saved through a form to the database.
* [Bug] output_language bug in template class.
* [Improved] Added the new PHPDevShell logo.
* [Bug] When a user jumped to a deeper menu item, where he does not have access to parent, the breadcrumb showed empty.
* [Bug] The dropdown menus when vertical enough hovers under the info icons when activated.
* [Improved] The menu system should now have the ability to dropdown until last child menu item is seen. Also with a more W3C approved approach which also allows vertical menus.
* [Improved] Cleanup of PHP E_ALL notices, many notices showed when using the E_ALL reporting of PHP.
* [Improved] The crypt key changes everytime you save, this should not happen as sometime you depend on a fixed crypt key.
* [Bug] The session setting that was broken was fixed, the setting itself was moved back into the config file.
* [Bug] When installing a plugin the Plugin manager shows query was empty when no query is even needed.
* [Improved] Users don't need a title in contact admin anymore.
* [Other] Many other small bugs and improvements was attended to.

Please submit bugs at https://bugs.launchpad.net/phpdevshell
If you dont submit the bugs we dont know about them!

PHPDevShell V 2.1.0-Stable-DB-2100 (Revision 708)
-------------------------------------------------
Information:
PHPDevShell V 2.1.0-Stable is a major maintenance release bringing more stability and added features to the table.

Most significant changes:
* [New] Plugin update check, allowing administrators to check if certain plugins have new updates available.
* [Improved] Plugin manager.
* [Improved] Session handling with unique sessions for multiple sites.
* [Improved] Groups can now have unlimited parents and children with alias, allowing much more flexible data management.
* [Improved] Token management GUI.
* [New] right_trim method added to strip a string at the end of a string.
* [Bug] Users can now suppress php function errors with the @ operator.
* [Bug] PHPDevShell GUI items being edited now also have icons to represent them.
* [Bug] Users that received the Content Encoding Error was fixed.
* [Bug] Domain names in language system are now correctly returned.
* [Bug] Other minor bugs fixed.

Please submit bugs at https://bugs.launchpad.net/phpdevshell
If you dont submit the bugs we dont know about them!

PHPDevShell V 2.0.0-Stable-DB-2000 (Revision 664)
-------------------------------------------------
Information:
PHPDevShell V 2.0.0-Stable is a major release and introduces the new XML configuration template and plugin system.
This resulted in plugin incompatibility with plugin config script hence naming this version 2.0.0.

Most significant changes:
* New XML plugin and template configuration system.
* Fixed view source script to be more robust.
* More robust plugin manager handling errors appropriately.
* Plugins can now have their own autoload functions.
* Improved hooks system with various multiple hook point bug fixed.
* Menu structure improvements made.
* Bug fixed in menu delete method where multiple menus needs deleting.
* Database class now handles errors better.
* Multiple small bugs were fixed.
* Additional improvements made to PHPDevShell plugin.

Please submit bugs at http://phpdevshell.org

PHPDevShell V 1.2.0-Stable-DB-1200 (Revision 592)
-------------------------------------------------
Information:
PHPDevShell V 1.2.0-Stable is a quick follow up to V 1.1.1, fixing all submitted bugs and introducing the new
Chrome template and a new theme manager.

Most significant changes:
-IMPROVED: When deleting access or system logs counter starts from 0 again.
-NEW: Function added to check if menu is used in settings before deleting it.
-IMPROVED: No results found updated in Chrome.
-NEW: Added option to have a message displayed in the registration and login screen.
-NEW: Added ability to link to items from other plugins and own plugin.
-IMPROVED: Navigation and execution system dramatically improved!
-UPDATE: DB Class improved to handle errors better and ability to amend html to filter box. [Thanks Maximus]
-IMPROVED: New improved menu system with added ability to link any menu type and not only certain types.
-UPDATE: Improved navigation and menu handling.
-IMPROVED: Improved login and logout screens.
-IMPROVED: Improved template manager and removed not needed string in plugin manager.
-UPDATE: Updated config for new menu structure with removed template screens.
-IMPROVED: New template manager introduced.
-NEW: Added template config files and added ability to assign default template to all menus at once.
-REMOVED: Dead icons in Chrome Template.
-IMPROVED: Improved system status layout.
-NEW: Added say thanks button on readme page.
-UPDATE: TinyMCE updated to version 3.2.0
-NEW: New Chrome template added.
-LOW LEVEL BUG FIX: Added missing mootools date picker gif files.
-CRITICAL BUG FIX: Front-page link did not work according to admin settings.
-LOW LEVEL BUG FIX: Removed stupid Thumbs files.
-LOW LEVEL BUG FIX: Fixed _Blank description in menu admin.
-LOW LEVEL BUG FIX: Control panel was made to only show relevant menus in its group.
-LOW LEVEL BUG FIX: Fixed ability to add parent plugin when creating a control panel for external plugin.

Please submit bugs at http://phpdevshell.org

PHPDevShell V 1.1.1-Stable-DB-1110 (Revision 560)
-------------------------------------------------
Information:
PHPDevShell V 1.1.1-Stable is a stable release with various improvements and features.
The most notible is the new Registration token and approval system.

Most significant changes:
-LOW LEVEL BUG FIX: Fixed plugin manager where core plugin produced a database error when deleting menu items.
-UPDATE: Updated plugin upgrade script.
-UPDATE: Updated upgrade and install sql scripts.
-LOW LEVEL BUG FIX: Fixed token that displayd deleted when false id is entered for deletion.
-UPDATE: Updated install instructions and plugin information.
-REMOVED: Removed not needed icons.
-UPDATE: Updated some text in classes.
-IMPROVED: Added checks to see if gui can delete and does not return a false message.
-NEW: Added funtion to quickly check access permission on a menu item.
-UPDATE: Updated say thanks link.
-CRITICAL BUG FIX: Fixed query email to admin bug where all email was send to user instead of admin!
-LOW LEVEL BUG FIX: Fixed text used in template class.
-NEW: Added login and logout animated graphics to improve user experience.
-IMPROVED: User login and logout.
-UPDATE: Removed thumbs directory.
-IMPROVED: Improved menu graphics and icons.
-NEW: Added IE6 Warning to template.
-IMPROVED: Improved control panel with improved message backgrounds.
-UPDATE: Added message function. Will display only a message style.
-IMPROVED: Improved PHPDevShell menu structure.
-NEW: Added images for token control.
-UPDATE: Control panel updated to allow lower level icons when placed in sub menu system.
-NEW: System now allows multiple host/domain installations from single core.
-UPDATE: Configuration file now sits in unique directory.
-NEW: New config folder.
-UPDATE: Wysiwyg  now calls wysiwyg config from specific setup.
-UPDATE: Moved wysiwyg to be plugin specific. This will allow greater customization.
-REMOVED: Removed custom wysiwyg editor.
-UPDATE: TinyMCE upgraded to V3.1.0.1 with improved class functionality.
-UPDATE: PHPMailer was updated to the long awaited V 2.2.1
-UPDATE: User registration and token system is now complete and found to be stable.
-UPDATE: Added notification for admin approved users.
-UPDATE: Added advanced notifications on registering.
-UPDATE: Improved registration email notification options.
-UPDATE: Finalized token registration model.
-LOW LEVEL BUG FIX: User errors did not show when registering.
-UPDATE: Optimizing registration script.
-NEW: User Pending management added, with ban and approve options per group and support for lower level admin.
-UPDATE: Register Finalized Improved.
-UPDATE: Improved General settings registration options.
-NEW: Added Email Token.
-UPDATE: Added dummy index.php file to prevent indexing.
-REMOVED: Removed ico shortcut as this is most probably not what people would want to see.
-REMOVED: Thumb creation file.
-UPDATE: Updated login image.
-IMPROVED: Improved template user experience.
-UPDATE: Improved Template with improved text and navigation.
-UPDATE: PHPDS now allows more custom module CSS attributes.
-UPDATE: Started with template module system.
-UPDATE: Improved image sets.
-TODO: Improve index.php login and logout. (Set guest)
-UPDATE: Updated database with new front_page_id_in.
-UPDATE: Updated database with new front_page_id_in.
-NEW: Ability added to select Frontpage Link when logged and and Frontpage link when logged in.
-NEW: New class checking login status of user.
-CSS FIX: Fixed small css error on input fields.
-CSS FIX: Fixed small css error on generic buttons.
-IMPROVED: Better logged in and logged out icons added.

Please submit bugs at http://phpdevshell.org

PHPDevShell V 1.0.0-Stable-DB-1001 (Revision 451)
-------------------------------------------------
Information:
PHPDevShell V 1.0.0-Stable is the stable release with various improvements and features.

Most significant changes:
-IMPROVED: Improved security features added to protect core properties.
-IMPROVED: Critical improved SMTP and other email options with encryption added.
-LOW LEVEL BUG FIX: Hooks edit did not point to correct menu item.
-LOW LEVEL BUG FIX: Fixed force core changes off as default installation.
-UPDATE: Fixed CSS where input boxes resided on warning message.
-NEW: Mootloos date picker added to system for easy date picking capabilities.
-UPDATE: Updated SimplePhonebook visuals.
-LOW LEVEL BUG FIX: Message returns returned empty.
-UPDATE: Visual improvements made.
-LOW LEVEL BUG FIX: Message returns returned empty.
-UPDATE: Generic glossy shine fixed with improved menu dropdowns.
-CRITICAL BUG FIX: Hooks did not work correctly with cache, cache on hooks improved.

Roadmap:
48 hour bug fix from time of report.
Code optimization.

PHPDevShell V 1.0.0-RC-1-DB-1001 (Revision 430)
-----------------------------------------------
Information:
PHPDevShell V 1.0.0-RC-1 is a maintenance release towards stable.

Most significant changes:
-UPDATE: Email message to admin gets decoded to correct html character.
-UPDATE: Improved CSS tooltip.
-NEW: When creating or editing a Role, permission to menu items can be assigned on the fly in the GUI.
-LOW LEVEL BUG FIX: System now allows admins to bypass system set to down if his session expired.
-UPDATE: Method added to enable decoding of html entities that was encoded to their correct html character.
-UPDATE: Control panel names now accepts longer names.
-LOW LEVEL BUG FIX: When logging in and wrong login details was used, system now redirects to login correctly.
-CRITICAL BUG FIX: Search filter listed more then it should when used.
-UPDATE: Improved method to prevent SQL injection while still allowing quotes.
-NEW: Plugin menu install now accepts "parent_plugin" property to modify menu owner. This allows you to install a menu item to another plugins directory structure.
-NEW: CSS, HTML and images is now correctly handled by gzip.

Roadmap:
48 hour bug fix from time of report.
Code optimization.

PHPDevShell V 0.9.5-Stable (Revision 350)
-----------------------------------------
Information:
a New super slick and light javascript AJAX framework called Mootools replaces PEAR::HTML_Ajax as it was not maintained as desired.
Mootools framework gives PHPDevShell great WEB 2.0 functionality.

Improvements:
-IMPROVED: Tooltips.
-NEW: AJAX framework (Mootools V 1.11).
-NEW: Javascript framework (Mootools V 1.11).
-BUG-FIX: Incorrect version was shown in plugin activation.

Roadmap:
24 hour bug fixes from time of report.
Code optimization.

PHPDevShell V 0.9.2-Stable (Revision 340)
-----------------------------------------
Information:
Release includes the new transaction system which is used for saver SQL transactions and the DEMO system.

Improvements:
-IMPROVED: Configuration System.
-IMPROVED: General Settings GUI.
-IMPROVED: Database error handling.
-NEW: Demo capabilities added.
-NEW: Database Transactions with Rollback and Commit.
-NEW: Menu access log disable option was added in General Settings GUI.

Database Changes (092):
Most table was modified to Engine InnoDB.

Roadmap:
24 hour bug fixes from time of report.
Code optimization.

PHPDevShell V 0.9.1-Stable (Revision 312)
-----------------------------------------
Information:
This minor release includes the new control panel and general GUI settings.

Improvements:
-IMPROVED: Configuration System.
-IMPROVED: Control Panel.
-BUG-FIX: a Minor bug was fixed where the filter system did not work with magic_quotes_enabled.
-NEW: Menu access log system was added.
-UPDATE: TinyMCE was updated to latest stable version (3.0.5).
-NEW: The PHPDevShell logo was updated with new logo.

Database Changes (091):
CREATE TABLE `pds_core_menu_access_logs`...

Roadmap:
24 hour bug fixes from time of report.
Code optimization.

PHPDevShell V 0.9.0-Stable (Revision 282)
-----------------------------------------
Information:
This is a major release, the system now uses the linux gettext system to support multilingual.
This allows the developer to skip working on a separate language file, improving productivity dramatically.

Improvements:
-IMPROVED: Language system.
-IMPROVED: Improved template system.
-IMPROVED: Security system.
-IMPROVED: Locale system.
-IMPROVED: Some class files was moved to support better structure.

Database Changes (090):
ALTER TABLE `pds_core_users`...

Language files modified or added;
Language system does not have external files anymore but supports multilingual better.

Roadmap:
24 hour bug fixes from time of report.
Code optimization.

PHPDevShell V 0.8.4-Stable (Revision 225)
-----------------------------------------
Information:
Small maintentance release, with the database converted to utf-8, and one bug fix.

Improvements:
-IMPROVED: Database converted to utf-8.

Bugs Fixed:
-CRITICAL BUG FIX: Some pages produced an error when "magic_quotes_gpc" is switched off in PHP and an $_POST action is done.

Database Changes:
All tables and columns converted to utf-8.

Language files modified or added;
None.

Roadmap:
Next major release will be PHPDevShell 0.9.0,
In this release developers will have the ability to write strings directly in scripts while still having full multilingual capabilities.
No external language files will be needed anymore. It will be based on the gettext PO language system.

PHPDevShell V 0.8.3-Stable (Revision 213)
-----------------------------------------
Information:
Maintenance release, this release addressed GUI bugs and some security enhancements.
Ships with improved logging system as well. Upgrading is highly recommended.

Improvements:
-SECURITY IMPROVEMENT: System can now run securely protecting itself and all scripts from SQL injections with PHP magic quotes switched off. (TitanKing)
-IMPROVED: "Contact admin" now tries to create a from address first, before asking address field. (TitanKing)
-IMPROVED: Filter rows now also gets deleted when menu item gets deleted. (TitanKing)
-IMPROVED: Improved logging system, user_logs merged with new logging system. (TitanKing)
-IMPROVED: On the log-in screen users can now see their history. (TitanKing)
-IMPROVED: Filter & search system can now be filtered by exact match as well. (TitanKing)
-NEW: Database old or up-to-date notification added in System Admin. (TitanKing)

Bugs Fixed:
-CRITICAL BUG FIX: Admin can not save user, database error was presented. (TitanKing)
-LOW LEVEL BUG FIX: Login/out variable moved to main language, in some cases it showed the undefined constant. (TitanKing)
-LOW LEVEL BUG FIX: User could not save general settings on fresh install. (TitanKing)
-LOW LEVEL BUG FIX: a Bug was fixed within the email class which renders wrong on some email clients. (TitanKing)

Database Changes:
* ALTER TABLE `pds_core_filter`...
* ALTER TABLE `pds_core_logs`...
* DROP TABLE `pds_core_user_logs`...

Language files modified or added;
* M /branches/0.8.x/plugins/PHPDevShell/language/en/en.register.php
* M /branches/0.8.x/plugins/PHPDevShell/language/en/en.email_admin.php
* M /branches/0.8.x/plugins/PHPDevShell/language/en/en.login_page.php
* M /branches/0.8.x/plugins/PHPDevShell/language/en/en.menu.php
* M /branches/0.8.x/plugins/PHPDevShell/language/en/en.system_logs.php
* D /branches/0.8.x/plugins/PHPDevShell/language/en/en.user_logs_admin.php
* M /branches/0.8.x/language/en/en.engine.php
* M /branches/0.8.x/plugins/PHPDevShell/language/en/en.admin.php
* M /branches/0.8.x/plugins/PHPDevShell/language/en/en.general_settings.php


PHPDevShell V 0.8.2-Stable (Revision 177)
-----------------------------------------
Information:
This is mainly a large maintenance upgrade and the introduction of the PEAR HTML_AJAX class.
Although PHPDevShell does not use AJAX to produce any stock information, it gives the developer an easy way to do things with AJAX.

Improvements:
* Essential settings now gets pulled from database only once and gets stored in global array.
* New and improved settings write, get and delete methods for the developer to use for plugin settings.
* PHPDevShell code was cleaned and coding format was improved.
* Language engine improved.
* Database engine improved.
* Updated readme introduction.
* Improved plugin manager with new developer functions.
* Any database value that gets delete now gets logged by name instead of id.
* Improved search engine where end user does not need to include asterix anymore when searching.
* Only root users can now delete logs, even if "other" roles are assigned to viewing logs.
* Updated TinyMCE wysiwyg to latest stable version 3.
* For better security search engine robots are now not allowed to index PHPDevShell directories.
* an Advanced timezone management per user an system default was implimented.
* Added PEAR Ajax capabilities with included example in SimplePhoneBook plugin.
* Various other small improvements...

Bugs Fixed:
* Fixed cron.run.php bug that was required by cron class.
* Fixed bug where guests was not set as correct groups or roles.
* Performance was improved by solving a multiple language define bug.
* Various other small bug fixes...

Database Changes:
* Added prefix to core settings database (You should to).
* ALTER TABLE `pds_core_users` ADD COLUMN `timezone`...

Language files modified or added;
M /branches/0.8.x/language/en/en.engine.php
M /branches/0.8.x/language/en/en.icon.php
M /branches/0.8.x/plugins/PHPDevShell/documents/readme.php
M /branches/0.8.x/plugins/PHPDevShell/language/en/en.readme.php
M /branches/0.8.x/plugins/PHPDevShell/language/en/en.hooks_admin.php
M /branches/0.8.x/plugins/PHPDevShell/language/en/en.hooks_admin_list.php
M /branches/0.8.x/language/en/en.engine.php
A /branches/0.8.x/language/en/en.timezone.php
M /branches/0.8.x/plugins/PHPDevShell/language/en/en.edit_preferences.php
M /branches/0.8.x/plugins/PHPDevShell/language/en/en.register.php
M /branches/0.8.x/plugins/PHPDevShell/language/en/en.user_admin.php
M /branches/0.8.x/plugins/PHPDevShell/language/en/en.menu.php
A /branches/0.8.x/plugins/SimplePhonebook/language/en/en.login_count.ajax.php
M /branches/0.8.x/plugins/SimplePhonebook/language/en/en.menu.php

PHPDevShell V 0.8.1-Stable
--------------------------
Information:
This release addresses some of the last major functions that could be required by developers including a lower level admin to manage users in his group.
Several bugs was fixed. The theme was improved to give it a more professional look and feel.
Logo management was added. More powerful security features was added.
PHPDevShell has now matured in a truly professional solution.

Improvements:
* Improved theme visuals and eye candy.
* Plugin manager improved.
* Minor readme improvements.
* Improved redirect method.
* Minor improvements to sample plugin.
* User can now choose plugin or custom logo as default application logo.
* Remove edit confirmation when requesting to edit an entry.
* Added "new" button to quickly create a new record.
* Search filter now stores a users filter and search preferences per script.
* Added form post validation method to ensure forms does not get posted externaly.
* Root users can now setup a lower level admin to handle users in a specific group only.
* Improved IP tracking behind proxy.
* Improved check if record exists method.

Bugs Fixed:
* Minor bugs fixed.

Database changes:
* ALTER TABLE `pds_core_plugin_activation`
* CREATE TABLE `pds_core_filter`

Language files modified or added;
* /plugins/PHPDevShell/language/en/en.readme.php
* /plugins/SimplePhonebook/language/en/en.icon.php
* /plugins/PHPDevShell/language/en/en.plugin_activation.php
* /language/en/en.engine.php
* /language/en/en.icon.php
* /plugins/PHPDevShell/language/en/en.user_admin.php
* /plugins/PHPDevShell/language/en/en.user_admin_list.php
* /plugins/PHPDevShell/language/en/en.user_group_admin_list.php
* /plugins/PHPDevShell/language/en/en.user_role_admin.php
* /plugins/PHPDevShell/language/en/en.user_group_admin.php
* /plugins/PHPDevShell/language/en/en.user_group_admin_list.php

PHPDevShell V 0.8.0-Stable
--------------------------
Information:
* In this version a major feature is introduces namely the hook system.
* Code was optimized.
* Useful function added.
* Improved error checking.
* Added log notification.
* Bugs fixed.

Improvements:
* Modular hook system was developed for PHPDevShell.
* Footer does not include hard coded PHPDevshell version anymore.
* Changed headed td tags into th tags where needed.
* Looped url functions changed to call only once when listing menu items.
* Changed the way queries are displayed in footer.
* In menu admin, the load_page happend inside the loop, this should happen only once.
* Added option to allow opening of menu items in _blank/new pages.
* Added option to email admin on critical errors.
* Upgraded PHPMailer class to PHPMailer 2.0.0-Stable.
* Ability to add multiple admin emails for notifications.
* Created new  method to get all installed plugins.
* Added queries count optional option.
* Removed template name as it is identified by the folder now.
* Slightly improved template look and feel.
* Created new  method to get all installed plugins.
* Added 4 icons to en.icon.php.
* Added truncate TABLE terms where needed!
* Removed looped load_page to single assigned variabled.
* Plugin manager now check dependencies.
* Removed standout look from input fields when hovering over them.
* Improved phonebook system to better support hook demo.
* Removed plugin names from heading in jump menu, we dont want everyone to see what plugins are used.
* Jump/Sitemap menu improved.
* Better error checking in general settings.
* Updated Tinymce to V2.1.3.
* Improved error checking.
* Improved deletion of groups and roles.
* Added empty option in dropdowns.
* Slightly improved CCS with headers, less stand out.
* Prepared development for lower level admin integration.

Bugs Fixed:
* NO security vulnerabilities was found!
* Fixed menu items that wont delete even if core changes are set to true.
* Added fix to not list .svn directories in plugin installation.
* Fixed type true (truez) in $template->warning.
* Query split used at incorrect location.
* Bug fixed in menu system, when user belongs to multiple roles, it duplicated the menu items.
* Bug that will not save primary group in user admin was fixed.
* Bug in registration fixed where user password comparing was incorrect.
* Fixed bug in menu admin where name was always determined.

Database changes:
Added _db_core_hooks table.
Dropped template_name from _db_core_templates.

Language files modified or added;
* /language/en/en.engine.php
* /language/en/en.icon.php
* /plugins/PHPDevShell/language/en/en.user_group_admin.php
* /plugins/PHPDevShell/language/en/en.menu.php
* /plugins/PHPDevShell/language/en/en.general_settings.php
* /plugins/PHPDevShell/language/en/en.jump_menu.php
* /plugins/PHPDevShell/language/en/en.menu_item_admin_permissions.php
* /plugins/PHPDevShell/language/en/en.menu_item_admin_template.php
* /plugins/SimplePhonebook/language/en/en.icon.php
* /plugins/SimplePhonebook/language/en/en.manage_entry.php
* /plugins/SimplePhonebook/language/en/en.menu.php
* /plugins/SimplePhonebook/language/en/en.plugin.php
* /plugins/SimplePhonebook/language/en/en.preferences.hook.php
* /plugins/SimplePhonebook/language/en/en.register.hook.php
* /plugins/PHPDevShell/language/en/en.plugin_activation.php
* /plugins/PHPDevShell/language/en/en.template_admin.php
* /plugins/PHPDevShell/language/en/en.template_admin_list.php
* /plugins/PHPDevShell/language/en/en.menu_item_admin_new_window.php
* /plugins/PHPDevShell/language/en/en.menu_item_admin_open.php
* /plugins/PHPDevShell/language/en/en.menu_item_admin.php
* /plugins/PHPDevShell/language/en/en.hooks_source_view.php (NEW)
* /plugins/PHPDevShell/language/en/en.hooks_admin_list.php (NEW)
* /plugins/PHPDevShell/language/en/en.hooks_admin.php (NEW)

Major todo's for PHPDevShell V 0.8.1-Stable:
* Search filters should be remembered.
* Lower level admin will be implemented which will allow him to add users to groups he belongs to.
* Plugins should run their own logos when they are active.
* a Resfresh button is needed on all pages to make the system resfresh the currently active page.
* Role needs to be delete from role database when a role gets deleted.

PHPDevShell V 0.7.0-Stable
--------------------------
Information:
This is a major release of PHPDevShell, and brings PHPDevShell into an extraordinary and unique class of its own.
Everyone is recommended to upgrade.

Improvements:
* Added Romanian translation. (Author: Raul Gherman)
* Cleaned up formatting of en.icon.php.
* Plugins can now have an en.icon.php and a en.plugin.php that is always available to all scripts in that plugin.
* Dynamic title added to template system.
* Core engine improved in general.
* Core outputs to templates can now be injected, allowing interception of default data.
* When executing a cronjob manualy, it now displays results inside the same script without loading an external template.
* System cron file that crontab must touch is much lighter and improved, saving resources on each touch.
* Cronjobs can now have individual language files.
* Slightly improved loggs class.
* Added alert popup. (Author: Don Schoeman)
* Option to skip cron execution logging per cron file.
* Added and improved Role and Group manager.
* Added cronjob, managing maximum stored logs.
* Ability to switch PHPDevShell off while keeping it on for Root user.
* Quick logout (reset) option added in header.
* Ability added to over-ride core data protection.
* en.engine.php was cleaned up.
* Listing group and roles info popup now does so without breaking the line.
* Ability to update extra groups, roles and user display name on the fly through user listing.
* Ability to add user group notes and role notes.
* Method to pull all users role id's with given user id.
* System menu controller was reduced with 1 query.
* Improved logout security.
* Methods added to check if records in database already exists.
* Language system dramatically enhanced.
* Languages can now be selected on user basis with bulletproof fallback.
* a Debug variable was added. Place $template->debug = 'Anything'; anywhere in your script and that debug message will be parsed out to the browser, usefull for debugging scripts.
* Menu item language are now loaded from files and not preset in database.
* Truly multilingual capabilities added.
* Default emails was changed from html emails to text emails.
* Verification email url is now encrypted.
* Email verification is now encoding and decoding url to ensure accurate activation.
* Other small system administration improvements made.
* On registration a email gets send to the system administrator with options to ban or approve user if feature is required.
* Active info area was improved.
* Default template logo area and logo smaller, it is not a CMS!
* Captcha fell away, other spam prevention was included that is not visible by the end user.
* No directories need to be made writable anymore, making PHPDevShell even more secure!
* Option to keep logs trimmed to a specified number, deleting oldest logs first.
* Page splitting now shows total number of records.
* New example plugin developed, simple phonebook!
* Added 2-click menu system, run any script in 2 clicks from anywhere!
* CSS Improved in breadcrumbs links area.
* Active link dropped, it was display twice.
* Permissions correctly set for default installation.
* Account approval email gets send to a approved user when he/she gets approved by admin.
* Account banned email gets send to a banned user when he/she gets banned by admin.

Bugs Fixed:
* Developers dit not have access to $configuration['template_folder'] in plugin language file.
* Small bug fixed with repair_database that stopped working when ran as system cron.
* Minor security bug in repair & optimize database.
* Security bug fixed in edit preferences.
* Menu bug fixed where hidden menu was still shown in dropdown.
* Jumpy links fixed in broken IE7.
* Bug fixed in User Preferences where details did not get updated!

Other:
* Template $template->output_version_number changed to $template->output_active_info.
* Template $template->breadcrumbs changed to $template->output_breadcrumbs.
* Template $template->menu changed to $template->output_menu.
* Language changes made to en.cronjob_admin_list.
* User id was always called with $user_id = $security->decrypt($_SESSION['user_id']), now only $configuration['user_id'] or $_SESSION['user_id'] is needed.
* Crypt warning message was removed.

PHPDevShell V0.6.0-Stable
-------------------------
Improvements:
* Template system improved to allow custom templates to be added on plugin installation.
* Larger captcha image to improve human reading.
* Added indicator to show if a template file exists.
* Added indicator to show if a script exists.
* Added ability to switch off system logging (done with configuration file).

Bugs Fixed:
* None Found.

Other:
* PHPDevShell license was changed from GNU/GPL to GNU/LGPL 2.1 to allow PHPDevShell to be used in proprietary software.
* Database : (Table Update) _pds_core_templates changed (Column) template_id (length) to '32' and removed (auto increment).
* Database : (Table Update) _pds_core_item_templates changed (Column) template_id to (unsigned).
* Database : (Rows Update) _pds_core_item_templates added correct values.
* Database : (Rows Update) _pds_core_templates added correct values.
* Database : (Rows Update) _pds_core_settings added correct values.
* Added method to create a unique id depending on folder name. This makes it possible to predict a id value if one has a unique name.

PHPDevShell V0.5.7-Gold
-------------------------
Improvements:
* Improved eye candy in default template, giving it a more corporate true application feel.
* Cleaned up default template CSS.
* Default template is now "Web 2" compliant.

Bugs Fixed:
* None found.

Other:
* In table PDS core changes, the following was done...

PHPDevShell V0.5.6-Stable
-------------------------
Improvements:
* Minor visual enhancements.
* Gui System Settings was improved.
* Added SMTP email server support with server setting under GUI general settings.
* Added login customized redirection option.
* PHPMailer is now build into PHPDevShell to handle its SMTP email capabilities.
* Awsome filter capabilities added to core search component with the ability to remember filter for active session, with no extra work needed from the developer.
* Added "no results" where no resulted rows should be returned in scripts with rows.

Bugs Fixed:
* Query split fixed where incorrectly used.
* When installing or upgrading a plugin, and a sql error occurs within the plugin, the system does not show it as installed or upgraded any more, it does not get logged either.
* Cronjob icon fixed.

Other:
* From _db_core_settings, removed column setting_id.
* Made setting_description primary key.
* Insert default login redirect option value.
* Added custom user registration page option in gui settings.

PHPDevShell V0.5.5-Stable
-------------------------
Improvements:
* Warning, Success and Critical icons replaced.
* Help icon added.
* Added database query counter.
* PHP error reporting override built in.

Bugs Fixed:
* Major bug found in settings database extraction, causing multiple unnecessary db queries, and can even lead to system crash.

Other:
PLEASE NOTE IT IS RECOMMENDED YOU UPGRADE ASAP!

PHPDevShell V0.5.4-Stable
-------------------------
Improvements:
* Guest accounts are now selected within the general configuration page.
* Users can now select multiple or single setting from the core->get_settings class.
* System checks for default encrypt key, for optimal security.
* Encryption for user id added, improves security, this prevents session hijacking.
* Templates can now be selected from a dropdown list for menus, each script can use its own template.
* a Template manager was added.
* Dropdown for custom templates added in Menu Admin.
* Ability to set default template style in configuration.
* User gets notified by email when he/she updates user profile.
* Password recovery security was improved.
* Users can't delete default/empty template.
* Build in core deletion prevention in some scripts.
* Logins and logouts user logs are now presented by icons.
* Admins can now leave password field unchanged when editing a user profile.
* Email notifications gets send to users whos profiles gets updated.
* Passwords gets check and generated if needed, when creating a new user.

Bugs Fixed:
* Custom templates configuration was fixed and now actually works.
* Showed edit confirmation when deleting.
* Minor bugs or scripting.
* Plugin activation gave template_folder error.
* Dropdown cut off fixed.
* Fixed foreach bug in Menu Admin when no groups are selected.

Other:
* Ran all system functions to test stability.
* Created core_templates table.
* Added default template to core_template table.
* Changed core_item_templates column type to integer and changed template_folder to template_id.
* Added 2 new template admin menu items.
* Configuration 'default_template' was removed from configuration.php
* Added setting to gui system configuration.

Tested Scripts:
* Readme - OK
* Login/Out - OK
* Registration Submit - OK
* Registration Admin Email - OK
* User registration activation Email - OK
* User registration activation - OK
* Email Admin - OK
* User Profile - OK
* Password Recovery - OK
* System Admin - OK
* General Settings - OK
* Plugin Activation - FIXED
* System Logs - OK
* User Logs - OK
* General Settings - OK
* Menu Admin - FIXED
* Menu Visibility - OK
* Menu Permission - OK
* Menu Template - OK
* Menu Rank - OK
* Template Admin - OK
* Template List - OK
* Cronjob Admin - OK
* Cronjob List - OK
* User Admin - OK
* User Listing - OK
* Group Admin - OK
* Group Admin List - OK

Tested Functions:
* Auto DB Results Paging - OK
* CSS Help Tooltip - OK
* Install Plugin - OK
* Uninstall Plugin - OK
* Reinstall Menus - OK
* Search Engine - OK
* Hiding a menu item - OK
* Manual Cronjob Execution - OK
* Auto Cronjob Execution - OK

PHPDevShell V0.5.2-Stable
-------------------------
Improvements:
* General settings have a more intuitive interface.
* User admin has a more intuitive interface.
* User group has a more intuitive interface.
* When a user is deleted, related family table is cleaned as well.
* Added session timeout option to config.
* Major security recoding and improvement done.
* Pages now remembers where to redirect to after login.
* Security settings and system settings changed, takes effect immediately.
* Captcha image is easier to read by humans now.

Bugs Fixed:
* Security : User login/password was accepted with lower and uppercase.
* Other security weak points was fixed.

Other:
* There is a possibility of a small performance decrease on some systems due to the extra security checks.

PHPDevShell V0.5.1-Stable
-------------------------
Improvements:
* DB V51
* Small clean up to engine script done.
* Menu item structure build now only happens when item is actually deleted.
* Improved load page method, with ability to add extra $_GET vars.
* Major improvements to the default template.
* "List Menu" was removed, delete and edit can now be done with any menu manipulation listing script.
* When submitting edit/delete $_POST was used, it was changed back to $_GET, allowing the use of other input forms.
* Menu system now shows parent as a menu as well when in active menu group, this helps make navigation easier.
* Cronjob system listing was replaced with $_GET actions, modified $_GET variables.
* Users can now select from a multi select box to choose which groups can access what scripts.

Bugs Fixed:
* Language constants was incorrect in cronjob admin scripts.
* Fixed error when logging out.

PHPDevShell V0.5.0-Stable
-------------------------
Improvements:
* Breadcrumbs are now first followed by menu items, for improved navigation.
* Language file added to readme.php
* All methods made public or private according to there type and structure.
* Interface was made touch screen friendly.
* Example plugin was expanded.
* Language updated.

Bugs Fixed:
* Broken breadcrumb array sorting.
* Incorrect plugin database query sorting method.
* Plugin class is searched for in wrong directory when in sub-levels.

Other:
* Small changes made to template css for improved navigation.
* Support for IE6 was dropped completely.

PHPDevShell V0.4.8-Stable
-------------------------
Improvements:
* Less configuration data information is required in configuration.php
* Less admin is required on menu items, as some processes are determined automaticly now.
* Ability to add an array of menu items to be deleted on upgrade through plugin manager.
* Example plugin config was updated.
* Added images to login page.

Bugs Fixed:
* Breadcrumb links was not correctly ordered.

Other:
* Removed table pds_core_item_groups, pds_core_item_owner as groups are now determined by plugin folder.
* Removed menu item 2110163404, 3554126791 and 3558205398 as groups are now determined by plugin folder.

PHPDevShell V0.4.7-Stable
-------------------------
Improvements:
* TinyMCE WYSIWYG updated to V 2.1.2 from V 2.1.1
* Leapfrog menu system with single level dropdown added.
* Core plugin structure changed.
* Css updated.
* Menu language system improved.
* PHPDevShell Core Upgrade system added through plugin manager.
* Breadcrumb system improved.

Bugs Fixed:
* Multiple bugs fixed in plugin system.
* Language method fixed, when deeper level plugins exist.
* Fixed scripts name not appearing in various user side scripts and emails.

Other:
* a Certain package was removed due to license issues.

PHPDevShell V0.4.6-Stable
-------------------------
Several features was tested, to check stability.

Improvements:
* When submitting edit/delete $_GET was used, it was changed to use $_POST, this has advantages.
* Minor improvements made to code throughout.
* Username gets logged intead of ID alone, incase username gets deleted.

Bugs Fixed:
* System Error produced when accessing an illegal page.
* Ranking by which menu items was saved was not according to user input when selecting rank last.
* Username not displaying in system logs.
* Username not displaying in user logs.